#include <hmg.ch>

Function Main

   public oDB := nil

   define window encrypt at 0, 0 width 400 height 300 title 'Encrypt DB' main
      DEFINE BUTTON SourceBtn
         ROW 10
         COL 100
         WIDTH 200
         CAPTION 'Select the source file'
         ACTION SelectSourceFile()
      END BUTTON
      DEFINE LABEL SourceFile
         ROW 40
         COL 10
         WIDTH 380
         FONTBOLD .t.
      END LABEL
      DEFINE BUTTON DestBtn
         ROW 70
         COL 100
         WIDTH 200
         CAPTION 'Select the Destination file'
         ACTION SelectDestFile()
      END BUTTON
      DEFINE LABEL DestFile
         ROW 100
         COL 10
         WIDTH 380
         FONTBOLD .t.
      END LABEL
      DEFINE LABEL PassLabel
         ROW 130
         COL 10
         WIDTH 100
         VALUE 'Enter Password'
      END LABEL
      DEFINE TEXTBOX Password
         ROW 130
         COL 110
         WIDTH 200
         PASSWORD .t.
      END TEXTBOX
      DEFINE BUTTON Encrypt
         ROW 170
         COL 110
         WIDTH 80
         CAPTION 'Encrypt'
         ACTION EncryptDB()
      END BUTTON   
      DEFINE BUTTON Decrypt
         ROW 170
         COL 210
         WIDTH 80
         CAPTION 'Decrypt'
         ACTION DecryptDB()
      END BUTTON   
	END WINDOW
   on key ESCAPE of encrypt action encrypt.release()
	Center Window encrypt
	Activate Window encrypt
Return

function EncryptDB()
   LOCAL lOk, aTable
   if oDB == Nil
      msgstop( 'Source database is not yet connected!' )
      return nil
   endif
   if len( alltrim( encrypt.DestFile.VALUE ) ) == 0
      msgstop( 'Destination file is not selected.' )
      return nil
   endif
   if len( alltrim( encrypt.password.VALUE ) ) == 0
      msgstop( 'You have to enter password for encryption' )
      return nil
   endif
   
   WAIT WINDOW 'Please Wait ...' NOWAIT
   lOk := miscsql( oDB, "attach database " + c2sql( encrypt.destfile.value ) + " as e key " + c2sql( encrypt.password.value ) )
   if .not. lOk
      msgstop( 'Database Error!' )
      WAIT CLEAR
   else
      aTable := sql( oDB, 'select type, sql, tbl_name from sqlite_master' )
      // creation process
      for i := 1 to len( aTable )
         do case
         case upper( alltrim( aTable[ i, 1 ] ) ) == 'TABLE' .and. substr( upper( alltrim( aTable[ i, 3 ] ) ), 1, 7 ) <> 'SQLITE_' 
            WAIT WINDOW 'Creating Table ' + aTable[ i, 3 ] + ' ...' NOWAIT
            if at( 'CREATE TABLE', aTable[ i, 2 ] ) > 0
               cQStr := strtran( aTable[ i, 2 ], 'CREATE TABLE', 'CREATE TABLE e.' )
               lOk := miscsql( oDB, cQStr )
               if .not. lOk
                  msgstop( 'Database Table ' + aTable[ i, 3 ] + ' creation error!' )
                  WAIT CLEAR
                  return nil
               endif
            endif
         case upper( alltrim( aTable[ i, 1 ] ) ) == 'INDEX'
            do case 
            case at( 'CREATE INDEX', aTable[ i, 2 ] ) > 0
               WAIT WINDOW 'Creating Index ' + aTable[ i, 3 ] + ' ...' NOWAIT
               cQStr := strtran( aTable[ i, 2 ], 'CREATE INDEX', 'CREATE INDEX e.' )
               lOk := miscsql( oDB, cQStr )
               if .not. lOk
                  msgstop( 'Database Index ' + aTable[ i, 3 ] + ' creation error!' )
                  WAIT CLEAR
                  return nil
               endif
            case at( 'CREATE UNIQUE INDEX', aTable[ i, 2 ] ) > 0
               WAIT WINDOW 'Creating Unique Index ' + aTable[ i, 3 ] + ' ...' NOWAIT
               cQStr := strtran( aTable[ i, 2 ], 'CREATE UNIQUE INDEX', 'CREATE UNIQUE INDEX e.' )
               lOk := miscsql( oDB, cQStr )
               if .not. lOk
                  msgstop( 'Database Unique Index ' + aTable[ i, 3 ] + ' creation error!' )
                  WAIT CLEAR
                  return nil
               endif
            otherwise 
//               msgstop( 'Could not run ' + aTable[ i, 2 ] )
            endcase
         otherwise 
//            msgstop( 'Could not run ' + aTable[ i, 2 ] )
         endcase            
      next i   
      
      // insert data 
      for i := 1 to len( aTable )
         do case
         case upper( alltrim( aTable[ i, 1 ] ) ) == 'TABLE' .and. substr( upper( alltrim( aTable[ i, 3 ] ) ), 1, 7 ) <> 'SQLITE_' 
            WAIT WINDOW 'Updating and Encrypting Table ' + aTable[ i, 3 ] + ' ...' NOWAIT
            cQStr := 'insert into e.' + alltrim( aTable[ i, 3 ] ) + ' select * from ' + alltrim( aTable[ i, 3 ] )
            lOk := miscsql( oDB, cQStr )
            if .not. lOk
               msgstop( 'Data can not be inserted ' + aTable[ i, 3 ] )
               WAIT CLEAR
               return nil
            endif
         endcase
      next i         
      lOk := miscsql( oDB, 'detach database e' )
      if .not. lOk
         msgstop( 'Database error!' )
         WAIT CLEAR
         return nil
      endif
      
   endif   
   WAIT CLEAR
   IF lOk
      MSGINFO( 'Destination File Successfully Created!' )
   ENDIF
   RETURN NIL   

function DecryptDB()
   LOCAL lOk, aTable, oDB1
   if oDB == Nil
      msgstop( 'Source database is not yet connected!' )
      return nil
   endif
   if len( alltrim( encrypt.DestFile.VALUE ) ) == 0
      msgstop( 'Destination file is not selected.' )
      return nil
   endif
   if len( alltrim( encrypt.password.VALUE ) ) == 0
      msgstop( 'You have to enter password for encryption' )
      return nil
   endif
   oDB := nil
   oDB := connect2db( encrypt.destfile.value, .t. )
   if oDB == nil
      msgstop( 'Destination Database can not be created!' )
      return nil
   endif
   
   WAIT WINDOW 'Please Wait ...' NOWAIT
   lOk := miscsql( oDB, "attach database " + c2sql( encrypt.sourcefile.value ) + " as e key " + c2sql( encrypt.password.value ) )
   if .not. lOk
      msgstop( 'Database Error!' )
      WAIT CLEAR
      return nil
   else
      aTable := sql( oDB, 'select type, sql, tbl_name from e.sqlite_master' )
      // creation process
      for i := 1 to len( aTable )
         do case
         case upper( alltrim( aTable[ i, 1 ] ) ) == 'TABLE' .and. substr( upper( alltrim( aTable[ i, 3 ] ) ), 1, 7 ) <> 'SQLITE_' 
            WAIT WINDOW 'Creating Table ' + aTable[ i, 3 ] + ' ...' NOWAIT
            if at( 'CREATE TABLE', aTable[ i, 2 ] ) > 0
               cQStr := aTable[ i, 2 ]
               lOk := miscsql( oDB, cQStr )
               if .not. lOk
                  msgstop( 'Database Table ' + aTable[ i, 3 ] + ' creation error!' )
                  WAIT CLEAR
                  return nil
               endif
            endif
         case upper( alltrim( aTable[ i, 1 ] ) ) == 'INDEX'
            do case 
            case at( 'CREATE INDEX', aTable[ i, 2 ] ) > 0
               WAIT WINDOW 'Creating Index ' + aTable[ i, 3 ] + ' ...' NOWAIT
               cQStr := aTable[ i, 2 ]
               lOk := miscsql( oDB, cQStr )
               if .not. lOk
                  msgstop( 'Database Index ' + aTable[ i, 3 ] + ' creation error!' )
                  WAIT CLEAR
                  return nil
               endif
            case at( 'CREATE UNIQUE INDEX', aTable[ i, 2 ] ) > 0
               WAIT WINDOW 'Creating Unique Index ' + aTable[ i, 3 ] + ' ...' NOWAIT
               cQStr := aTable[ i, 2 ]
               lOk := miscsql( oDB, cQStr )
               if .not. lOk
                  msgstop( 'Database Unique Index ' + aTable[ i, 3 ] + ' creation error!' )
                  WAIT CLEAR
                  return nil
               endif
            otherwise 
//               msgstop( 'Could not run ' + aTable[ i, 2 ] )
            endcase
         otherwise 
//            msgstop( 'Could not run ' + aTable[ i, 2 ] )
         endcase            
      next i   
      
      // insert data 
      for i := 1 to len( aTable )
         do case
         case upper( alltrim( aTable[ i, 1 ] ) ) == 'TABLE' .and. substr( upper( alltrim( aTable[ i, 3 ] ) ), 1, 7 ) <> 'SQLITE_' 
            WAIT WINDOW 'Decrypting and Updating Table ' + aTable[ i, 3 ] + ' ...' NOWAIT
            cQStr := 'insert into ' + alltrim( aTable[ i, 3 ] ) + ' select * from e.' + alltrim( aTable[ i, 3 ] )
            lOk := miscsql( oDB, cQStr )
            if .not. lOk
               msgstop( 'Data can not be inserted ' + aTable[ i, 3 ] )
               WAIT CLEAR
               return nil
            endif
         endcase
      next i         
      lOk := miscsql( oDB, 'detach database e' )
      if .not. lOk
         msgstop( 'Database error!' )
         WAIT CLEAR
         return nil
      endif
      MSGINFO( 'Destination File Successfully Created!' )
   endif   
   WAIT CLEAR
   RETURN NIL   
   
   

FUNCTION SelectSourceFile()
   LOCAL cFileName
   cFileName := alltrim( GetFile( { { "All Files", "*.*" } }, "Select the source file" , , .f., .f. ) )
   encrypt.SourceFile.VALUE := cFileName
   oDB := connect2db( cFileName, .f. )
   if oDB == nil
      msgstop( 'Source Database can not be opened!' )
   endif
   RETURN NIL
      
FUNCTION SelectDestFile()
   LOCAL cFileName
   cFileName := alltrim( PutFile( { { "All Files", "*.*" } }, "Select the destinaton file" , , .f., .f. ) )
   encrypt.DestFile.VALUE := cFileName
   if file( cFileName )
      if msgyesno( 'File already exists! Are you sure to overwrite?' )
         if .not. ferase( cFileName ) == 0
            msgstop( 'File can not be created!' )
            encrypt.destfile.value := ''
         endif
      endif
   endif
   RETURN NIL
